#include <fxlib.h>
#include "HUFFMAN.h"
#include "MonochromeLib.h"
#include "Compresseur.h"
#include "File.h"

int Compresser(void) {
	struct {
		unsigned char oct;
		unsigned int eff;
		int pere;
		char code;
		char code_compresse[16];
	} _Feuilles[257] = { {0, 0, 0, 0} };
	struct {
		unsigned int eff;
		int pere;
		char code;
	} _Noeuds[257] = {{0, 0, 0}};
	int _Tab[257];

	const unsigned char ANALYSE[]={0xee, 0xe9, 0x5d, 0xff, 0xaa, 0xa9, 0x51, 0x3f, 0xea, 0xe8, 0x9d, 0xff, 0xaa, 0xa8, 0x85, 0x3f, 0xaa, 0xae, 0x9d, 0xff, };
	const unsigned char ECRITURE[]={0xee, 0xee, 0xea, 0xef, 0x88, 0xa4, 0x4a, 0xa9, 0xe8, 0xc4, 0x4a, 0xcf, 0x88, 0xa4, 0x4a, 0xa9, 0xee, 0xae, 0x4e, 0xaf, };
	const unsigned char TRAITEMENT[]={0xee, 0xee, 0xee, 0xae, 0xef, 0x4a, 0xa4, 0x48, 0xe8, 0xa5, 0x4c, 0xe4, 0x4e, 0xae, 0xa5, 0x4a, 0xa4, 0x48, 0xa8, 0xa5, 0x4a, 0xae, 0x4e, 0xae, 0xa5, };
	unsigned int key, eff_1, eff_2, sav_u_int;
	unsigned char taille_max = 0; 		//	taille (en bits) du plus grand octet compressé
	unsigned char File_original_char[13] = "", File_compressed_char[13] = "", sav_u_char, c;
	float new_file_size_octs;		//	Taille du fichier compressé en octets
	long new_file_size_bytes = 3;	//	Taille du fichier compressé en bits (initialisé à 2)
	float file_size;		//	Taille du fichier original (en octets)
	char param = 4;		//	Taille du deuxième paramètre de l'arbre
	int i = 0, fin_du_nom, handle, new_handle, total, j, k, _Tab_size, taux;
	int total_octets = 0;		//	Le nombre total d'octets différents dans _Feuilles
	int nombre_noeuds = 0;		//	Indique le nombre de noeuds qui existent déjà dans _Noeuds
	FONTCHARACTER Path_name_base[]={'\\','\\','f','l','s','0','\\','*',0}, path_name[20], File_original[13], File_compressed[13], File_to_open[80], File_to_create[80];
    opt_tri tri = TAILLE_DECROISSANT;


/********************************** Initialisation **********************************/
	Display_PopUp(1, "", 0);
	do {
		GetKey(&key);
	}while(key != KEY_CTRL_EXE);
	if(User_Choose_File(Path_name_base, path_name, File_original, 20, tri, 1, 1)) return 0;

	while(File_original[i] != 0) {
		File_compressed[i] = File_original[i];
		i++;
	}
	File_compressed[i] = 0;
	i = 0;
	while(File_original[i] != '\0') {
		File_original_char[i] = File_original[i];
		i++;
	}
	Display_PopUp(2, File_original_char, 0);
	if(Oui_ou_Non(37) == 0) return 0;

	ML_clear_vram();
	locate__Print((int)(10 - (strlen(File_original_char)/2)), 1, "\"");
	Print(File_original_char);
	Print("\"");
	ML_horizontal_line(9, 0, 127, ML_BLACK);
	ML_horizontal_line(10, 0, 127, ML_BLACK);
	ML_bmp_or(ANALYSE, 2, 20, 26, 5);
	ML_rectangle(43, 19, 125, 25, 1, ML_BLACK, ML_WHITE);
	ML_bmp_or(TRAITEMENT, 2, 33, 39, 5);
	ML_rectangle(43, 32, 125, 38, 1, ML_BLACK, ML_WHITE);
	ML_bmp_or(ECRITURE, 2, 46, 31, 5);
	ML_rectangle(43, 45, 125, 51, 1, ML_BLACK, ML_WHITE);
	ML_display_vram();


/**************************************** Analyse ***************************************/
	fin_du_nom = FONTCHARACTER_search(File_compressed, '.');
	if(fin_du_nom == 0) while(File_compressed[fin_du_nom] != 0) fin_du_nom++;
	if(fin_du_nom > 8) fin_du_nom = 8;
	File_compressed[fin_du_nom] = '.';
	File_compressed[fin_du_nom + 1] = 'h';
	File_compressed[fin_du_nom + 2] = 'u';
	File_compressed[fin_du_nom + 3] = 'f';
	File_compressed[fin_du_nom + 4] = '\0';

	FONTCHARACTER_cat(path_name, File_original, File_to_open);
	handle = Bfile_OpenFile(File_to_open, _OPENMODE_READ);
	if(handle < 0) {
		Display_PopUp(3, File_original_char, 0);
		GetKey(&key);
		return 0;
	}
	file_size = Bfile_GetFileSize(handle);
	if(file_size < 50) {
		Display_PopUp(4, File_original_char, 0);
		GetKey(&key);
		return 0;
	}

	SetTimer(1, 50, Display_Progression_Analyse);
	progression_actuelle = 0;
	progression_maximale = file_size;
	curseur_read = TAB_TO_READ_SIZE;
	while(1) {		//	À la fin de ce bloc, _Feuilles contient tous les octets du fichier et leur occurence
		j = Read_Octet(handle);
		if(j < 0) break;
		progression_actuelle++;

		for(i = 0; i < total_octets; i++) {
			if(_Feuilles[i].oct == j) {
				_Feuilles[i].eff ++;
				break;
			}
		}
		if(i == total_octets) {
			_Feuilles[i].oct = j;
			_Feuilles[i].eff = 1;
			total_octets ++;
		}
	}
	KillTimer(1);
	ML_rectangle(44, 20, 124, 24, 0, 0, ML_BLACK);
	ML_display_vram();

	if(total_octets == 256) {					//	Trie le tableau _Feuilles s'il y a 256 octets différents
		for(k = 0; k < 256; k++) {			//	Ce tri se fait du plus petit octet au plus grand
			for(j = k; j < 256; j++) {
				total = 0;
				for(i = k; i < 256; i++)
					if(_Feuilles[j].oct > _Feuilles[i].oct) total++;
				if(total == 0) {
					sav_u_char = _Feuilles[k].oct;
					_Feuilles[k].oct = _Feuilles[j].oct;
					_Feuilles[j].oct = sav_u_char;
					sav_u_int = _Feuilles[k].eff;
					_Feuilles[k].eff = _Feuilles[j].eff;
					_Feuilles[j].eff = sav_u_int;
					j = 256;
				}
			}
		}
	}


/*************************************** Traitement **************************************/
	for(i = 0; i < total_octets; i++)		//	Initialise _Tab, qui contient maintenant 0,1,2,...,n,-1
		_Tab[i] = i;
	_Tab[i] = -1;

	SetTimer(1, 50, Display_Progression_Traitement);
	progression_actuelle = 0;
	progression_maximale = total_octets;
	while(_Tab[1] != -1) {					//	Boucle: tant qu'il n'y a pas qu'un seul noeud racine

		_Tab_size = 0;
		while(_Tab[_Tab_size] != -1) _Tab_size++;

		if(_Tab_size > 2) {								//	Trie les 2 premiers éléments de _Tab (le plus petit en premier)
			for(k = 0; k < 2; k++) {
				for(j = k; j < _Tab_size; j++) {
					total = 0;
					for(i = k; i < _Tab_size; i++) {
						//	Fonction "effectif" impossible à implanter ici
						if(_Tab[j] < 256) eff_1 = _Feuilles[_Tab[j]].eff;
						else eff_1 = _Noeuds[_Tab[j] - 256].eff;
						if(_Tab[i] < 256) eff_2 = _Feuilles[_Tab[i]].eff;
						else eff_2 = _Noeuds[_Tab[i] - 256].eff;
						if(eff_1 > eff_2) total++;
					}
					if(total == 0) {
						sav_u_int = _Tab[k];
						_Tab[k] = _Tab[j];
						_Tab[j] = sav_u_int;
						j = _Tab_size;
					}
				}
			}
		}
		progression_actuelle++;
					//	Les blocs suivants créent un noeud en assemblant les deux premiers éléments de _Tab.
		//	Tableau des noeuds: Ajoute un effectif dans la première case libre.
		//	Fonction "effectif" impossible à implanter ici
		if(_Tab[0] < 256) eff_1 = _Feuilles[_Tab[0]].eff;
		else eff_1 = _Noeuds[_Tab[0] - 256].eff;
		if(_Tab[1] < 256) eff_2 = _Feuilles[_Tab[1]].eff;
		else eff_2 = _Noeuds[_Tab[1] - 256].eff;
		_Noeuds[nombre_noeuds].eff = eff_1 + eff_2;

		//	Ajoute l'adresse précédente + 256 dans .pere
		//	Ajoute le numéro 0 au premier, 1 au second dans .code
		if(_Tab[0] < 256) {
			_Feuilles[_Tab[0]].pere = nombre_noeuds + 256;
			_Feuilles[_Tab[0]].code = 0;
		}
		else {
			_Noeuds[_Tab[0]-256].pere = nombre_noeuds + 256;
			_Noeuds[_Tab[0]-256].code = 0;
		}
		if(_Tab[1] < 256) {
			_Feuilles[_Tab[1]].pere = nombre_noeuds + 256;
			_Feuilles[_Tab[1]].code = 1;
		}
		else {
			_Noeuds[_Tab[1]-256].pere = nombre_noeuds + 256;
			_Noeuds[_Tab[1]-256].code = 1;
		}

		//	Tableau _Tab: décale tout le tableau vers le haut,
		//  puis remplace la première case par l'adresse du noeud crée
		for(i = 1; i < _Tab_size; i++)
			_Tab[i] = _Tab[i+1];
		_Tab[0] = nombre_noeuds + 256;

		//  Incrémente la variable nombre_noeuds indiquant le nombre de noeuds
		nombre_noeuds ++;
	}

	for(i = 0; i < total_octets; i++)					//	Initialise la chaîne de caractères .code_compresse de _Feuilles[1 à total_octets] à '2'
		for(j = 0; j < 16; j++)
			_Feuilles[i].code_compresse[j] = 2;

	for(j = 0; j < total_octets; j++) {							//	Génère le code compressé de chaque octet en remontant l'arbre binaire jusqu'à sa racine
		i = _Feuilles[j].pere - 256;
		_Feuilles[j].code_compresse[0] = _Feuilles[j].code;
		k = 1;
		while (_Noeuds[i].pere) {
			_Feuilles[j].code_compresse[k] = _Noeuds[i].code;
			i = _Noeuds[i].pere - 256;
			k++;
		}
	}
	KillTimer(1);
	
	for(i = 0; i < total_octets; i++) {							//	Inverse le code compressé de chaque octet
		k = 0;
		while(_Feuilles[i].code_compresse[k] != 2)	k++;
		for(j = 0; j < (k/2); j++) {
			sav_u_int = _Feuilles[i].code_compresse[j];
			_Feuilles[i].code_compresse[j] = _Feuilles[i].code_compresse[k-j-1];
			_Feuilles[i].code_compresse[k-j-1] = sav_u_int;
		}
	}

	//	Calcul de la taille du fichier compressé
	if(total_octets != 256) new_file_size_bytes += 8;
	for(j = 0; j < total_octets; j++) {
		i = 0;
		while(_Feuilles[j].code_compresse[i] != 2)	i++;
		if(i > taille_max) taille_max = i;
	}
	if (taille_max <= 2) param = 1;
	else if (taille_max <= 4) param = 2;
	else if (taille_max <= 8) param = 3;

	for(i = 0; i < total_octets; i++) {
		if(total_octets != 256) new_file_size_bytes += 8;
		j = 0;
		while(_Feuilles[i].code_compresse[j] != 2) j++;
		new_file_size_bytes += (j*_Feuilles[i].eff + j + param);
	}
	new_file_size_bytes += 24;
	new_file_size_octs = new_file_size_bytes/8;
	if(new_file_size_bytes%8) new_file_size_octs ++;
	taux = 100-((new_file_size_octs*100)/file_size);
	
	ML_rectangle(44, 33, 124, 37, 0, 0, ML_BLACK);
	ML_display_vram();

	//	Si le fichier compressé est plus grand que le fichier original
	if(new_file_size_octs >= file_size) {
		SaveDisp(SAVEDISP_PAGE1);
		Display_PopUp(5, "", 0);
		if(Oui_ou_Non(51) == 0) return 0;
		ML_clear_vram();
		RestoreDisp(SAVEDISP_PAGE1);
	}
	
	k = 0;
	while(File_compressed[k] != '\0') {
		File_compressed_char[k] = File_compressed[k];
		k++;
	}

	//	Création du fichier compressé
	j = 1;
	while(j) {
		FONTCHARACTER_cat(path_name, File_compressed, File_to_create);
		i = Bfile_CreateFile(File_to_create, new_file_size_octs);
		if(i == IML_FILEERR_ALREADYEXISTENTRY) {
			SaveDisp(SAVEDISP_PAGE1);
			Display_PopUp(6, File_compressed_char, 0);
			Type_and_add_extension(5, File_compressed, File_compressed_char);
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE1);
		}
		else if (i < 0) {
			Display_PopUp(7, "", new_file_size_octs);
			GetKey(&key);
			return 0;
		}
		else j = 0;
	}


/*************************************** Ecriture **************************************/
	progression_maximale = new_file_size_bytes;
	progression_actuelle = 0;
	SetTimer(1, 50, Display_Progression_Ecriture);

	new_handle = Bfile_OpenFile(File_to_create, _OPENMODE_WRITE);
	if(new_handle < 0) {
		Display_PopUp(8, "", 0);
		GetKey(&key);
		return 0;
	}

	Init_Tab_curseur();
	add_bytes_to_write(file_size, 24);
	if(total_octets == 256)	add_bytes_to_write(0x01, 1);
	else {
		curseur_write++;
		add_bytes_to_write(total_octets - 1, 8);
	}
	add_bytes_to_write(param-1, 2);

	for(i = 0; i < total_octets; i++) {
		if(total_octets != 256)
			add_bytes_to_write(_Feuilles[i].oct, 8);
		j = 0;
		while(_Feuilles[i].code_compresse[j] != 2)	j++;
		add_bytes_to_write(j-1, param);
		add_str_to_write(_Feuilles[i].code_compresse, new_handle);
	}

	Bfile_SeekFile(handle, 0);
	curseur_read = TAB_TO_READ_SIZE;
	while(1) {
		j = Read_Octet(handle);
		if(j < 0) break;
		i = 0;
		while(_Feuilles[i].oct != j)	i++;
		add_str_to_write(_Feuilles[i].code_compresse, new_handle);
	}

	KillTimer(1);
	Bfile_WriteFile(new_handle, tab_to_write, ((long)new_file_size_octs)%TAB_TO_WRITE_SIZE);
	ML_rectangle(44, 46, 124, 50, 0, 0, ML_BLACK);


	Bfile_CloseFile(new_handle);
	Bfile_CloseFile(handle);
	Display_PopUp(9, "", taux);
	if(Oui_ou_Non(42))
		if(Bfile_DeleteFile(File_to_open) < 0) {
			Display_PopUp(10, File_original_char, 0);
			GetKey(&key);
		}
	Display_PopUp(11, File_compressed_char, file_size-new_file_size_octs);
	do {
		GetKey(&key);
	} while(key != KEY_CTRL_EXE);
}


int Oui_ou_Non(int y) {
	unsigned int key, c = 1;
	PrintXY(30, y, "OUI     NON", 0);
	do {
		if(c == 1) {
			PrintXY(25, y, "\xe6\xa1", 0);
			PrintXY(47, y, "\xe6\xa2", 0);
			PrintXY(73, y, " ", 0);
			PrintXY(96, y, " ", 0);
		}
		else {
			PrintXY(25, y, " ", 0);
			PrintXY(47, y, " ", 0);
			PrintXY(73, y, "\xe6\xa1", 0);
			PrintXY(96, y, "\xe6\xa2", 0);
		}
		GetKey(&key);
		if(key == KEY_CTRL_LEFT)		c = 1;
		else if(key == KEY_CTRL_RIGHT)	c = 0;
	} while(key != KEY_CTRL_EXE);
	return c;
}
void locate__Print(char x, char y, const char str[]) {
	locate(x, y);
	Print(str);
}
void Display_PopUp(char n, const char str[], long number) {
	unsigned int key;
	switch (n) {
		case 1:
			PopUpWin(3);
			locate__Print(3, 3, "Veuillez choisir");
			locate__Print(3, 4, "un fichier \xE6\x01");
			locate__Print(3, 5, "compresser");
			break;
		case 2:
			PopUpWin(5);
			locate__Print(3, 2, "Compresser le");
			locate__Print(3, 3, "fichier :");
			locate__Print(3, 4, "\"");
			Print(str);
			Print("\" ?");
			break;
		case 3:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible");
			locate__Print(3, 4, "d'ouvrir le");
			locate__Print(3, 5, "fichier :");
			locate__Print(4, 6, "\"");
			Print(str);
			Print("\"");
			break;
		case 4:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Le fichier");
			locate__Print(3, 4, "\"");
			Print(str);
			Print("\"");
			locate__Print(3, 5, "est trop petit.");
			locate__Print(3, 6, "( < \xE6\x01 50 octets)");
			break;
		case 5:
			PopUpWin(6);
			locate__Print(3, 2, "Le fichier");
			locate__Print(3, 3, "compress\xe6\x0a sera");
			locate__Print(3, 4, "plus grand que");
			locate__Print(3, 5, "l'original.");
			locate__Print(3, 6, "Compresser ?");
			break;
		case 6:
			SaveDisp(SAVEDISP_PAGE1);
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 4, "Le fichier");
			locate__Print(3, 5, "\"");
			Print(str);
			Print("\"");
			locate__Print(3, 6, "existe d\xe6\x0aj\xe6\x01.");
			GetKey(&key);
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE1);
			PopUpWin(3);
			locate__Print(3, 3, "Rentrer nouveau");
			locate__Print(3, 4, "nom :");
			break;
		case 7:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 4, "Echec de cr\xe6\x0a""ation");
			locate__Print(3, 5, "du fichier");
			locate__Print(3, 6, "compress\xe6\x0a !");
			GetKey(&key);
			PopUpWin(5);
			locate__Print(3, 2, "V\xe6\x0arifiez qu'il");
			locate__Print(3, 3, "reste");
			Afficher_Nombre(number, 45, 16);
			locate__Print(3, 4, "octets libres");
			locate__Print(3, 5, "dans la m\xe6\x0amoire");
			locate__Print(3, 6, "de stockage.");
			break;
		case 8:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible");
			locate__Print(3, 4, "d'ouvrir le");
			locate__Print(3, 5, "fichier compres-");
			locate__Print(3, 6, "s\xe6\x0a cr\xe6\x0a""\xe6\x0a !");
			break;
		case 9:
			SaveDisp(SAVEDISP_PAGE1);
			PopUpWin(5);
			locate__Print(7, 2, "Termin\xe6\x0a !");
			locate__Print(3, 4, "Taux de");
			locate__Print(3, 5, "compression :");
			locate__Print(4 + Afficher_Nombre(number, 13, 40), 6, "%");
			GetKey(&key);
			PopUpWin(5);
			locate__Print(3, 2, "Voulez-vous");
			locate__Print(3, 3, "supprimer le");
			locate__Print(3, 4, "fichier");
			locate__Print(3, 5, "original ?");
			break;
		case 10:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible de");
			locate__Print(3, 4, "supprimer le");
			locate__Print(3, 5, "fichier");
			locate__Print(3, 6, "\"");
			Print(str);
			Print("\"");
			break;
		case 11:
			PopUpWin(6);
			locate__Print(7, 2, "Termin\xe6\x0a !");
			locate__Print(3, 4, "le fichier");
			locate__Print(3, 5, "compress\xe6\x0a est :");
			locate__Print(4, 7, "\"");
			Print(str);
			Print("\"");
			GetKey(&key);
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE1);
			PopUpWin(2);
			locate__Print(4, 3, "Vous avez gagn\xe6\x0a");
			locate__Print(6 + Afficher_Nombre(number, 25, 25), 4, "octets");
	}
}

int Read_Octet(int handle) {
	if(curseur_read == TAB_TO_READ_SIZE) {
		curseur_read_max = Bfile_ReadFile(handle, tab_to_read, TAB_TO_READ_SIZE, -1);
		if(curseur_read_max < 0) return -1;
		curseur_read = 0;
	}
	if(curseur_read == curseur_read_max) return -1;
	curseur_read ++;
	return tab_to_read[curseur_read-1];
}

void add_bytes_to_write(int octet, char nb_bytes) {
	int i;
	for(i = nb_bytes-1; i >= 0; i--) {
		if ((1 << i) & octet)
			tab_to_write[curseur_write/8] |= (1 << (7-(curseur_write%8)));
		curseur_write++;
		progression_actuelle++;
	}
}
void add_str_to_write(const char str[], int new_handle) {
	int i = 0;
	unsigned int key;
	while(str[i] != 2){
		if(str[i])
			tab_to_write[curseur_write/8] |= (1 << (7-(curseur_write%8)));
		curseur_write++;
		progression_actuelle++;
		if(curseur_write == 8*TAB_TO_WRITE_SIZE) {
			Bfile_WriteFile(new_handle, tab_to_write, TAB_TO_WRITE_SIZE);
			Init_Tab_curseur();
		}
		i++;
	}
}
void Init_Tab_curseur(void) {
	int i;
	for(i = 0; i < TAB_TO_WRITE_SIZE; i++) tab_to_write[i] = 0;
	curseur_write = 0;
}
