#include <fxlib.h>
#include "HUFFMAN.h"
#include "Decompresseur.h"
#include "MonochromeLib.h"
#include "File.h"

static int handle, curseur_read_bytes;

int Decompresser(void) {
	struct {
		unsigned char oct;
		char oct_comp[16];
	} _Arbre[256];			//	Tableau de structure qui contient chaque octet du fichier d'origine et son éqivalent compressé
	const unsigned char ANALYSE[]={0xee, 0xe9, 0x5d, 0xff, 0xaa, 0xa9, 0x51, 0x3f, 0xea, 0xe8, 0x9d, 0xff, 0xaa, 0xa8, 0x85, 0x3f, 0xaa, 0xae, 0x9d, 0xff, };
	const unsigned char ECRITURE[]={0xee, 0xee, 0xea, 0xef, 0x88, 0xa4, 0x4a, 0xa9, 0xe8, 0xc4, 0x4a, 0xcf, 0x88, 0xa4, 0x4a, 0xa9, 0xee, 0xae, 0x4e, 0xaf, };
	unsigned int key;
	int i, j, new_handle;
	char File_original_char[13] = "", File_decompressed_char[13] = "", exit, code[17], *ext = 0;
	FONTCHARACTER Path_name_base[]={'\\','\\','f','l','s','0','\\','*','.','h','u','f',0}, path_name[20], File_original[13], File_decompressed[13], File_to_open[80], File_to_create[80];
	opt_tri tri = DOSSIERS_DEVANT_ORDRE_ALPHABETIQUE;
	unsigned char il_y_256_o, taille_o_compresses;
	long curseur_max;		//	Passé ce curseur dans le fichier compressé, les bits sont nuls et ne doivent pas être pris en compte
	int new_file_size = 0;	//	Taille du nouveau fichier décompressé (en octets)
	int total_octets;		//	Nombre total d'octets dans _Arbre (1 ~ 256)
	char taille_compressee;	//	taille (en bits) de l'octet compressé qui va suivre la position actuelle du curseur


/********************************** Initialisation **********************************/
	Display_PopUp_D(1, "", 0);
	do {
		GetKey(&key);
	}while(key != KEY_CTRL_EXE);
	if(User_Choose_File(Path_name_base, path_name, File_original, 20, tri, 1, 1)) return 0;

	i = 0;
	while(File_original[i]) {
		File_decompressed[i] = File_original[i];
		File_original_char[i] = File_original[i];
		i++;
	}
	File_decompressed[i] = 0;
	File_original_char[i] = 0;
	Display_PopUp_D(3, File_original_char, 0);
	if(Oui_ou_Non(37) == 0) return 0;

	ML_clear_vram();
	locate__Print((int)(10 - (strlen(File_original_char)/2)), 1, "\"");
	Print(File_original_char);
	Print("\"");
	ML_horizontal_line(9, 0, 127, ML_BLACK);
	ML_horizontal_line(10, 0, 127, ML_BLACK);
	ML_bmp_or(ANALYSE, 3, 20, 26, 5);
	ML_rectangle(43, 19, 125, 25, 1, ML_BLACK, ML_WHITE);
	ML_bmp_or(ECRITURE, 3, 33, 31, 5);
	ML_rectangle(43, 32, 125, 38, 1, ML_BLACK, ML_WHITE);
	ML_display_vram();


/************************************** SAISIE NOM **************************************/
	i = 0;
	while(File_decompressed[i]){
		File_decompressed_char[i] = File_original_char[i];
		i++;
	}
	
	SaveDisp(SAVEDISP_PAGE1);
	Display_PopUp_D(2, "", 0);
	Type_and_add_extension(4, File_decompressed, File_decompressed_char);
	ML_clear_vram();
	RestoreDisp(SAVEDISP_PAGE1);


/**************************************** Analyse ***************************************/
	FONTCHARACTER_cat(path_name, File_original, File_to_open);
	handle = Bfile_OpenFile(File_to_open, _OPENMODE_READ);
	if(handle < 0) {
		Display_PopUp_D(4, File_original_char, 0);
		GetKey(&key);
		return 0;
	}

	curseur_read = TAB_TO_READ_SIZE;
	new_file_size = Lire_Nombre(24);
	il_y_256_o = Lire_Nombre(1);				//	Valeur du 4ème bit du fichier compressé : 1 signifie qu'il y avait 256 octets différents dans le fichier d'origine
	total_octets = 256;							//	Nombre total d'octets différents dans le fichier d'origine
	if(!il_y_256_o) total_octets = Lire_Nombre(8)+1;
	taille_o_compresses = Lire_Nombre(2)+1;		//	la taille de chaque octet compressé sera codée sur x bits (de 1 à 4)

	for(i = 0; i < 256; i++) {			//	Initialise _Arbre.oct à 0~255 et _Arbre.oct_comp[] à "2"
		_Arbre[i].oct = i;
		for(j = 0; j < 16; j++)
			_Arbre[i].oct_comp[j] = 2;
	}
	for(j = 0; j < total_octets; j++) {		//	Parcourt le fichier compressé pour reconstituer l'arbre
		if(il_y_256_o == 0)
			_Arbre[j].oct = Lire_Nombre(8);	//	lit l'octet normal, non compressé, et le stocke dans _Arbre (uniquement si le 4ème bit du fichier compressé est 0)
		taille_compressee = Lire_Nombre(taille_o_compresses);	// sur taille_o_compresses, lit le nombre de bytes que l'octet compressé occupera
		for(i = 0; i <= taille_compressee; i++)
			_Arbre[j].oct_comp[i] = Lire_Byte();
	}
	ML_rectangle(44, 20, 124, 24, 0, 0, ML_BLACK);
	ML_display_vram();


/**************************************** Ecriture ***************************************/
	FONTCHARACTER_cat(path_name, File_decompressed, File_to_create);
	new_handle = Bfile_CreateFile(File_to_create, new_file_size);
	if(new_handle == IML_FILEERR_ALREADYEXISTENTRY){
		Display_PopUp_D(5, File_decompressed_char, 0);
		GetKey(&key);
		return 0;
	}
	if(new_handle < 0) {
		Display_PopUp_D(6, "", new_file_size);
		GetKey(&key);
		return 0;
	}
	new_handle = Bfile_OpenFile(File_to_create, _OPENMODE_WRITE);
	if(new_handle < 0) {
		Display_PopUp_D(7, "", 0);
		GetKey(&key);
		return 0;
	}

	curseur_write = 0;
	progression_maximale = new_file_size;
	progression_actuelle = 0;
	SetTimer(1, 50, Display_Progression_Traitement);

	exit = 0;
	while(progression_actuelle < new_file_size) {
		i = 0;
		exit = 0;
		for(j = 0; j < 16; j++)	code[j] = 2;

		while(!exit) {
			code[i] = Lire_Byte();
			for(j = 0; j < total_octets; j++) {
				if(Comparer(code, _Arbre[j].oct_comp) == 0){
					exit = 1;
					break;
				}
			}
			i++;
			if(i > 16) exit = 1;
		}
		progression_actuelle++;
		Write_octet(_Arbre[j].oct, new_handle);
	}
	KillTimer(1);
	Bfile_WriteFile(new_handle, tab_to_write, TAB_TO_WRITE_SIZE);
	ML_rectangle(44, 33, 124, 37, 0, 0, ML_BLACK);


/*************************************  Fin  *************************************/
	Bfile_CloseFile(handle);
	Bfile_CloseFile(new_handle);
	Display_PopUp_D(8, "", 0);
	if(Oui_ou_Non(42)) {
		if(Bfile_DeleteFile(File_to_open) < 0) {
			Display_PopUp_D(9, File_original_char, 0);
			GetKey(&key);
		}
	}
}

void Display_PopUp_D(char n, const char str[], long number) {
	unsigned int key;
	switch (n) {
		case 1:
			PopUpWin(3);
			locate__Print(3, 3, "Veuillez choisir");
			locate__Print(3, 4, "un fichier \xE6\x01");
			locate__Print(3, 5, "d\xe6\x0a""compresser");
			break;
		case 2:
			PopUpWin(2);
			locate__Print(3, 3, "Entrer extension:");
			break;
		case 3:
			PopUpWin(5);
			locate__Print(3, 2, "D\xe6\x0a""compresser le");
			locate__Print(3, 3, "fichier :");
			locate__Print(3, 4, "\"");
			Print(str);
			Print("\" ?");
			break;
		case 4:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible");
			locate__Print(3, 4, "d'ouvrir le");
			locate__Print(3, 5, "fichier :");
			locate__Print(4, 6, "\"");
			Print(str);
			Print("\"");
			break;
		case 5:
			PopUpWin(6);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Le fichier");
			locate__Print(3, 4, "\"");
			Print(str);
			Print("\"");
			locate__Print(3, 5, "existe d\xe6\x0aj\xe6\x01.");
			locate__Print(3, 6, "Supprimez-le ou");
			locate__Print(3, 7, "renommez-le.");
			break;
		case 6:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 4, "Echec de cr\xe6\x0a""ation");
			locate__Print(3, 5, "du fichier");
			locate__Print(3, 6, "d\xe6\x0a""compress\xe6\x0a !");
			GetKey(&key);
			PopUpWin(5);
			locate__Print(3, 2, "V\xe6\x0arifiez qu'il");
			locate__Print(3, 3, "reste");
			Afficher_Nombre(number, 45, 16);
			locate__Print(3, 4, "octets libres");
			locate__Print(3, 5, "dans la m\xe6\x0amoire");
			locate__Print(3, 6, "de stockage.");
			break;
		case 7:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible");
			locate__Print(3, 4, "d'ouvrir le");
			locate__Print(3, 5, "fichier d\xe6\x0a""comp-");
			locate__Print(3, 6, "ress\xe6\x0a cr\xe6\x0a""\xe6\x0a !");
			break;
		case 8:
			PopUpWin(1);
			locate__Print(7, 4, "Termin\xe6\x0a !");
			GetKey(&key);
			PopUpWin(5);
			locate__Print(3, 2, "Voulez-vous");
			locate__Print(3, 3, "supprimer le");
			locate__Print(3, 4, "fichier");
			locate__Print(3, 5, "compress\xe6\x0a ?");
			break;
		case 9:
			PopUpWin(5);
			locate__Print(5, 2, "== ERREUR ==");
			locate__Print(3, 3, "Impossible de");
			locate__Print(3, 4, "supprimer le");
			locate__Print(3, 5, "fichier");
			locate__Print(3, 6, "\"");
			Print(str);
			Print("\"");
	}
}
int Lire_Nombre(char nb_bytes) {			//	Renvoie un nombre qui s'étend sur nb_bytes bits du fichier compressé à décoder
	int o = 0, i;
	for(i = nb_bytes-1; i >= 0; i--)
		o |= (Lire_Byte() << i);
	return o;
}
char Lire_Byte(void) {								//	Renvoie le bit suivant dans le fichier compressé (0 ou 1). La position du bit est fixée par les curseurs curseur_read et curseur_read_bytes
	if((curseur_read == TAB_TO_READ_SIZE) || ((curseur_read_bytes == 8) && (curseur_read == TAB_TO_READ_SIZE-1))){
		curseur_read_max = Bfile_ReadFile(handle, tab_to_read, TAB_TO_READ_SIZE, -1);
		if(curseur_read_max < 0) return -1;
		curseur_read = 0;
		curseur_read_bytes = 0;
	}
	if(curseur_read == curseur_read_max) return -1;
	curseur_read_bytes ++;
	if(curseur_read_bytes == 9){
		curseur_read_bytes = 1;
		curseur_read++;
	}
	if((1 << (8-curseur_read_bytes)) & tab_to_read[curseur_read]) return 1;
	return 0;
}
int Comparer(const char ch1[], const char ch2[]) {	//	Compare les deux chaînes de caractères (terminées par un '2'). Renvoie 0 si identiques, 1 sinon
	int i = 0;
	do{
		if(ch1[i] != ch2[i]) return 1;
		if( (ch1[i] == ch2[i]) && (ch1[i] == 2) ) return 0;
		i++;
	} while(1);
}

void Write_octet(unsigned char oct, int new_handle) {
	tab_to_write[curseur_write] = oct;
	curseur_write++;
	if(curseur_write == TAB_TO_WRITE_SIZE) {
		Bfile_WriteFile(new_handle, tab_to_write, TAB_TO_WRITE_SIZE);
		curseur_write = 0;
	}
}