#include <fxlib.h>
#include "MonochromeLib.h"
#include "BetterFont.h"
#include "HUFFMAN.h"
#include "Compresseur.h"
#include "Decompresseur.h"
#include "EasyInput.h"


unsigned char tab_to_write[TAB_TO_WRITE_SIZE];
unsigned char tab_to_read[TAB_TO_READ_SIZE];
int curseur_read, curseur_read_max, progression_maximale, progression_actuelle, curseur_write;

int AddIn_main(int isAppli, unsigned short OptionNum) {
	unsigned int key;
	const unsigned char FILE_COMPRESSOR[]={0xfb, 0xe8, 0x3e, 0x0, 0x3c, 0xe4, 0x5e, 0x79, 0xf3, 0xcf, 0x39, 0xef, 0x80, 0x88, 0x20, 0x0, 0x41, 0x16, 0xd1, 0x45, 0x4, 0x10, 0x45, 0x1f, 0xe0, 0x88, 0x38, 0x0, 0x41, 0x15, 0x5e, 0x79, 0xc3, 0x8e, 0x45, 0xef, 0x80, 0x88, 0x20, 0x0, 0x41, 0x14, 0x50, 0x45, 0x0, 0x41, 0x45, 0x1f, 0x83, 0xef, 0xbe, 0x0, 0x3c, 0xe4, 0x50, 0x45, 0xf7, 0x9e, 0x39, 0x1f, };
	const unsigned char AIDE[]={0xfd, 0xff, 0xcf, 0x31, 0xb5, 0x57, 0xb5, 0x53, 0x85, 0x57, 0xb5, 0x31, 0xff, 0xff, };
	const unsigned char CREDITS[]={0xff, 0xfe, 0xff, 0xff, 0xd3, 0x27, 0x8c, 0xff, 0xb5, 0x6a, 0xdb, 0xff, 0xb3, 0x2a, 0xdd, 0xff, 0xb5, 0x6a, 0xde, 0xff, 0xd5, 0x26, 0xd9, 0xff, 0xff, 0xff, 0xff, 0xff, };
	char c = 0;
	
	do {
		ML_clear_vram();
		ML_bmp_or(FILE_COMPRESSOR, 18, 3, 92, 5);
		ML_horizontal_line(4, 2, 15, ML_BLACK);
		ML_horizontal_line(6, 2, 15, ML_BLACK);
		ML_horizontal_line(4, 112, 125, ML_BLACK);
		ML_horizontal_line(6, 112, 125, ML_BLACK);
		ML_horizontal_line(11, 0, 128, ML_BLACK);
		ML_horizontal_line(12, 0, 128, ML_BLACK);
		ML_vertical_line(60, 13, 63, ML_BLACK);
		ML_bmp_or(AIDE, 0, 57, 16, 7);
		ML_bmp_or(CREDITS, 18, 57, 25, 7);
		dispStr("Compresser", 7, 22);
		dispStr("D\x89""compresser", 3, 35);
		SaveDisp(SAVEDISP_PAGE1);

		do {
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE1);
			if(c == 0) {
				ML_rectangle(2, 22, 52, 28, 0, 0, ML_XOR);
				dispStr("Compresser un fichier (.g1a, .g1m, .g1r, .txt, etc...)\nLe fichier compress\x89 a l'extension .huf", 63, 14);
			}
			if(c == 1) {
				ML_rectangle(2, 35, 51, 41, 0, 0, ML_XOR);
				dispStr("D\x89""compresser un fichier inutilisable .huf cr\x89""\x89.\nRestauration du fichier original, utilisable.", 63, 15);
			}
			ML_rectangle(62, 14, 127, 63, 0, 0, ML_XOR);
			GetKey(&key);

			if(key == KEY_CTRL_F1) Aide();
			else if(key == KEY_CTRL_F2) Credits();

			if(key == KEY_CTRL_DOWN)	c=1;
			else if(key == KEY_CTRL_UP)	c=0;
		}while(key != KEY_CTRL_EXE);

		if(c == 0) Compresser();
		else Decompresser();
	}while(1);

	return 1;
}

int Aide(void) {
	const unsigned char AIDE[]={0xfb, 0xef, 0x3f, 0x88, 0x88, 0xa1, 0x88, 0x88, 0xa1, 0xf8, 0x88, 0xbf, 0x88, 0x88, 0xa1, 0x88, 0x88, 0xa1, 0x8b, 0xef, 0x3f, };
	unsigned int key;
	char i = 0;

	ML_clear_vram();
	ML_bmp_or(AIDE, 53, 1, 23, 7);
	ML_horizontal_line(9, 0, 127, ML_BLACK);
	dispStr("Cette application permet de compresser, puis de d\x89""compresser un fichier trop lourd pr\x89sent dans la m\x89moire de la calculatrice.", 1, 11);
	dispStr("Aide \x91 la compression", 10, 45);
	dispStr("Aide \x91 la d\x89""compression", 10, 53);
	SaveDisp(SAVEDISP_PAGE2);
	do {
		do {
			ML_clear_vram();
			RestoreDisp(SAVEDISP_PAGE2);
			if(i == 0) dispStr("\x80", 5, 45);
			else dispStr("\x80", 5, 53);
			GetKey(&key);

			if(key == KEY_CTRL_DOWN) i = 1;
			else if(key == KEY_CTRL_UP) i = 0;
			if(key == KEY_CTRL_EXIT) return 0;
		} while(key != KEY_CTRL_EXE);
		ML_clear_vram();
		ML_bmp_or(AIDE, 53, 1, 23, 7);
		ML_horizontal_line(9, 0, 127, ML_BLACK);
		if(i == 0)	dispStr("compression", 5, 11);
		else	dispStr("d\x89""compression", 5, 11);
		ML_rectangle(0, 11, 127, 18, 0, 0, ML_XOR);
		ML_horizontal_line(20, 0, 127, ML_BLACK);
		SaveDisp(SAVEDISP_PAGE3);

		if(i == 0) Aide_compression();
		else Aide_decompression();
	}while(1);
}
int Aide_compression(void) {
	dispStr("Lorsque vous compressez un fichier, le fichier compress\x89 aura l'extension .huf", 1, 23);
	if(Wait(1, 6)) return 0;
	dispStr("S'il n'y a plus assez de place dans la m\x89moire de votre calculatrice pour cr\x89""er le fichier compress\x89, la compression sera impossible.", 1, 23);
	if(Wait(2, 6)) return 0;
	dispStr("Les fichiers trop petits (inf\x89rieurs \x91 50 octets) ne sont pas pris en charge.", 1, 23);
	if(Wait(3, 6)) return 0;
	dispStr("Le fichier compress\x89 est inutilisable.", 1, 23);
	if(Wait(4, 6)) return 0;
	dispStr("Le taux de compression moyen est de l'ordre de 10 \x91 80 % selon la structure du fichier.", 1, 23);
	if(Wait(5, 6)) return 0;
	dispStr("Enfin, si le taux de compression n'est pas suffisant, vous pouvez toujours compresser de nouveau le fichier compress\x89 !", 1, 23);
	Wait(6, 6);
	return 0;
}
int Aide_decompression(void) {
	dispStr("Lorsque vous d\x89""compressez un fichier, il vous sera demand\x89 une extension \x91 attribuer au nouveau fichier d\x89""compress\x89.", 1, 23);
	if(Wait(1, 4)) return 0;
	dispStr("Seuls les fichiers .huf sont pris en charge.", 1, 23);
	if(Wait(2, 4)) return 0;
	dispStr("Si vous avez compress\x89 plusieurs fois de suite un fichier, vous devez le d\x89""compresser autant de fois.", 1, 23);
	if(Wait(3, 4)) return 0;
	dispStr("S'il n'y pas assez de m\x89moire dans votre calculatrice pour cr\x89""er le fichier d\x89""compress\x89, la d\x89""compression sera impossible.", 1, 23);
	Wait(4, 4);
	return 0;
}
int Wait(char a, char b) {
	unsigned int key;
	Afficher_Nombre_Betterfont(a, 116, 57);
	dispStr("\\", 120, 57);
	Afficher_Nombre_Betterfont(b, 124, 57);
	ML_rectangle(115, 57, 127, 63, 0, 0, ML_XOR);
	do {
		GetKey(&key);
	} while ((key != KEY_CTRL_EXE) && (key != KEY_CTRL_EXIT));
	ML_clear_vram();
	RestoreDisp(SAVEDISP_PAGE3);
	if(key == KEY_CTRL_EXIT) return 1;
	return 0;
}
int Credits(void) {
	unsigned int key;
	short a=0, c;
	const unsigned char Realisation_Bibliotheques[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xa, 0xc, 0x8, 0x31, 0x21, 0x86, 0x18, 0x66, 0x7e, 0xc, 0xf, 0xc3, 0xc3, 0xff, 0xff, 0x99, 0x9b, 0x36, 0x6c, 0xd3, 0xb3, 0x33, 0x33, 0x26, 0x7f, 0x36, 0x6f, 0xe7, 0x99, 0xff, 0xff, 0x9f, 0x9b, 0x36, 0x7c, 0xd3, 0xb3, 0x3f, 0x33, 0x22, 0x7f, 0x36, 0x7f, 0xe7, 0x99, 0xff, 0xff, 0xc3, 0x9b, 0xe, 0x1c, 0x33, 0xb3, 0x87, 0x33, 0x24, 0x7f, 0x36, 0x1f, 0xe7, 0x81, 0xff, 0xff, 0xf9, 0x9b, 0x3e, 0x7c, 0xd9, 0x73, 0xf3, 0x33, 0x26, 0x7f, 0x36, 0x7f, 0xe7, 0x99, 0xff, 0xff, 0x99, 0x9b, 0x3e, 0x6c, 0xd9, 0x73, 0x33, 0x33, 0x26, 0x7f, 0x36, 0x6f, 0xe6, 0x99, 0xff, 0xff, 0xc3, 0xc6, 0x1c, 0x8, 0x5c, 0xe1, 0x86, 0x18, 0x66, 0x7e, 0xc, 0xf, 0xc0, 0x99, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc1, 0x81, 0x86, 0x1c, 0x30, 0xe1, 0x81, 0xc, 0x33, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe6, 0xcd, 0x33, 0x3e, 0x66, 0x4c, 0xa5, 0x99, 0x93, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe6, 0xcf, 0x33, 0x3e, 0x67, 0xcc, 0xe7, 0x99, 0x91, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe1, 0xc3, 0x3, 0x3e, 0x70, 0xc0, 0xe7, 0x99, 0x92, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe6, 0xcf, 0x33, 0x3e, 0x7e, 0x4c, 0xe7, 0x99, 0x93, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe6, 0xcd, 0x33, 0x36, 0x66, 0x4c, 0xe7, 0x99, 0x93, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc2, 0x81, 0x32, 0x4, 0x30, 0xcc, 0xc3, 0xc, 0x33, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0xfb, 0xff, 0x7f, 0xc7, 0xf0, 0xc6, 0x1c, 0x6e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x18, 0x63, 0xf1, 0xbb, 0xef, 0xba, 0xeb, 0xa6, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc1, 0x6b, 0xdd, 0x76, 0x87, 0xef, 0x82, 0x1b, 0xaa, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x6b, 0xdd, 0x76, 0xbf, 0xef, 0xba, 0xeb, 0xac, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x6c, 0x63, 0x96, 0xc7, 0xf0, 0xba, 0xec, 0x6e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x37, 0x78, 0xe3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd7, 0xff, 0x5f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x17, 0x78, 0x67, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0xd7, 0x77, 0x7b, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0x39, 0x98, 0xc7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xb1, 0xfd, 0xe3, 0xff, 0xc7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xbe, 0xa5, 0xfa, 0xd4, 0xfb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xb0, 0x9d, 0xba, 0xd3, 0xc3, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfb, 0xae, 0xbc, 0x7a, 0xd7, 0xbb, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x71, 0xbd, 0xa7, 0x37, 0xc7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x30, 0x83, 0xe, 0x18, 0x60, 0x42, 0x81, 0x86, 0x14, 0xc, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xd9, 0xcd, 0x9f, 0x33, 0x29, 0x66, 0xcd, 0x33, 0x36, 0x69, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xd9, 0xcd, 0x9f, 0x33, 0x39, 0xe6, 0xcf, 0x33, 0x36, 0x79, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x39, 0xc3, 0x9f, 0x33, 0x39, 0xe0, 0xc3, 0x33, 0x36, 0x1c, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xd9, 0xcd, 0x9f, 0x33, 0x39, 0xe6, 0xcf, 0x7, 0x36, 0x7f, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0xd9, 0xcd, 0x9b, 0x33, 0x39, 0xe6, 0xcd, 0xcf, 0x36, 0x69, 0x9f, 0xff, 0xff, 0xff, 0xff, 0xf8, 0x30, 0x83, 0x2, 0x18, 0x70, 0xc2, 0x81, 0xe3, 0x8c, 0xc, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc9, 0xff, 0xff, 0xff, 0xef, 0xff, 0xff, 0xfe, 0xfb, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd5, 0x8c, 0x71, 0x8e, 0x29, 0xa6, 0x32, 0xe2, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x75, 0xae, 0xb5, 0xe6, 0x9d, 0xd5, 0x5a, 0xfb, 0x87, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x75, 0xae, 0xb5, 0xee, 0xbd, 0xd5, 0x46, 0xfb, 0xbb, 0x87, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0x8d, 0xb1, 0xb6, 0x2e, 0xbe, 0x35, 0x62, 0xc, 0x87, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf, 0xff, 0xff, 0xff, 0xf7, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x75, 0xff, 0xff, 0xfe, 0xf7, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x77, 0xe2, 0x94, 0xc6, 0x17, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xd, 0xda, 0x73, 0xba, 0xf7, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7d, 0xc6, 0xf7, 0xba, 0xf7, 0xdf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7e, 0x62, 0xf7, 0xc7, 0x10, 0x41, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc3, 0xff, 0xff, 0xff, 0x83, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0xff, 0xff, 0xff, 0xbf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdd, 0xfb, 0xdf, 0xff, 0xbf, 0xff, 0xdf, 0xff, 0x7, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xc3, 0x88, 0x43, 0x14, 0x8f, 0x18, 0xc3, 0xff, 0xee, 0x21, 0x8c, 0xb7, 0xac, 0x7f, 0xff, 0xff, 0xdd, 0x6b, 0xde, 0xd3, 0xbe, 0xeb, 0x5f, 0xff, 0xdd, 0xbb, 0x75, 0x51, 0xab, 0x7f, 0xff, 0xff, 0xdd, 0x1b, 0xde, 0x37, 0xbe, 0xeb, 0x5f, 0x87, 0xbc, 0x77, 0x75, 0x56, 0xd8, 0xff, 0xff, 0xff, 0xc3, 0x8c, 0x63, 0x17, 0xbf, 0x1b, 0x63, 0xff, 0x6, 0x21, 0x8d, 0x51, 0xbc, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc1, 0xff, 0xff, 0xf8, 0x3f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xdf, 0xff, 0xf, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xfc, 0x71, 0xfe, 0xff, 0xff, 0xc3, 0xff, 0x76, 0x3f, 0xbf, 0xe2, 0x1f, 0xff, 0xff, 0xff, 0xc7, 0x8f, 0xaf, 0x5e, 0xe3, 0x1b, 0x5f, 0xff, 0x77, 0xd4, 0xbf, 0xde, 0xf8, 0xd2, 0x5f, 0xff, 0xdf, 0x6c, 0x33, 0x5e, 0xed, 0x6b, 0x5f, 0xff, 0x76, 0x13, 0xb7, 0xe6, 0xf7, 0x4e, 0xaf, 0xff, 0xdf, 0x1b, 0xbd, 0xbe, 0xed, 0x6b, 0x5f, 0x87, 0x75, 0xd7, 0x8f, 0xfa, 0xf7, 0x5e, 0xaf, 0xff, 0xc1, 0x8c, 0x63, 0x78, 0x2d, 0x1c, 0xe3, 0xff, 0xe, 0x37, 0xb7, 0xc7, 0x18, 0xde, 0xaf, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0xff, 0xff, 0xf8, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xde, 0xef, 0xff, 0xfb, 0xb1, 0xfd, 0xf0, 0x7f, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xc7, 0xef, 0x1f, 0xfb, 0xbe, 0xa5, 0xfe, 0xda, 0x9e, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xde, 0xee, 0xdf, 0xfb, 0xb0, 0x9d, 0xb6, 0xda, 0x70, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xde, 0xee, 0x3c, 0x3b, 0xae, 0xbc, 0x76, 0xda, 0xee, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xdf, 0x33, 0x1f, 0xf8, 0x71, 0xbd, 0xb9, 0xe6, 0xf1, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, };
	const unsigned char LogoPlaneteCasio[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x90, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x50, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x51, 0xe5, 0xe3, 0xce, 0x78, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x90, 0x16, 0x14, 0x24, 0x84, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x11, 0xf4, 0x17, 0xc4, 0xf8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x12, 0x14, 0x14, 0x4, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x40, 0x9, 0xe4, 0x13, 0xe2, 0x7c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0x80, 0x0, 0x0, 0xff, 0xf0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xff, 0xf0, 0x0, 0xf, 0x0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xfe, 0x0, 0x70, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xe0, 0xf, 0x81, 0x80, 0x0, 0x0, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0x0, 0x0, 0xf6, 0x1, 0xff, 0xf0, 0x20, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3c, 0x0, 0x0, 0x18, 0xe, 0x0, 0xe, 0x10, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7c, 0x0, 0x0, 0x20, 0x70, 0x0, 0x1, 0x88, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7c, 0x0, 0x0, 0x41, 0xe0, 0x0, 0x0, 0x44, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7e, 0x0, 0x0, 0x82, 0x18, 0x0, 0x0, 0x32, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7e, 0x0, 0x1, 0xf, 0xff, 0xe0, 0x0, 0x9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x2, 0x3f, 0xff, 0xf0, 0x0, 0x5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x0, 0x4, 0x7f, 0xff, 0xf8, 0x0, 0x2, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0x80, 0x8, 0xbe, 0x0, 0x78, 0x0, 0x2, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xc0, 0x9, 0x3c, 0x0, 0x7c, 0x0, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xe0, 0x12, 0x3c, 0x0, 0x7b, 0x0, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xf0, 0x24, 0x3c, 0x0, 0xf8, 0x80, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xf8, 0x28, 0x3f, 0xff, 0xf0, 0x60, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfc, 0x50, 0x3f, 0xff, 0xe0, 0x10, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xfe, 0x50, 0x3f, 0xff, 0x80, 0x8, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xff, 0xa0, 0x3c, 0x0, 0x0, 0x6, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xff, 0xa0, 0x3c, 0x0, 0x0, 0x1, 0x1, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xe0, 0x3c, 0x3, 0xfe, 0x0, 0x81, 0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xe0, 0x3c, 0xf, 0xff, 0x0, 0x42, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xf0, 0x3c, 0x1f, 0xff, 0x80, 0x22, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0xff, 0xfc, 0x3c, 0x3f, 0x7, 0x80, 0x12, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xfe, 0x1c, 0x3e, 0x0, 0x0, 0xc, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0x80, 0x3c, 0x0, 0x0, 0x5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xc0, 0x3c, 0x0, 0x0, 0x9, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xff, 0xe0, 0x3c, 0x0, 0x0, 0xb, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xf, 0xff, 0xf8, 0x3c, 0x7, 0x0, 0x13, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xfc, 0x3c, 0xf, 0x80, 0x14, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0x3f, 0xff, 0x80, 0x28, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xff, 0xff, 0xbf, 0xff, 0x0, 0x48, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x90, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x7f, 0xff, 0xff, 0xf8, 0x1, 0x20, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x3f, 0xff, 0xfe, 0x0, 0x2, 0x40, 0x18, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x1f, 0xff, 0xff, 0x80, 0x4, 0x80, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x17, 0xff, 0xff, 0xe0, 0x19, 0x0, 0xc, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x9, 0xff, 0xff, 0xf8, 0x22, 0x0, 0xe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x84, 0x7f, 0xff, 0xfe, 0xc4, 0x0, 0xe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x42, 0x1f, 0xff, 0xff, 0x88, 0x0, 0xe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x21, 0x87, 0xff, 0xff, 0xf0, 0x0, 0xe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x18, 0x71, 0xff, 0xff, 0xfe, 0x0, 0x1e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0xf, 0xff, 0xff, 0xff, 0xc0, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x1f, 0xff, 0xff, 0xff, 0xfe, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xfc, 0x3e, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0xff, 0xf8, 0x41, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3f, 0xff, 0xff, 0xf0, 0x40, 0x3c, 0x7d, 0x3c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0xff, 0xff, 0xc0, 0x40, 0x2, 0x80, 0x42, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0x0, 0x40, 0x3e, 0x79, 0x42, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0xfc, 0x0, 0x41, 0x42, 0x5, 0x42, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3e, 0x3c, 0xf9, 0x3c, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, };
	float b=0;
	
	ML_clear_vram();
	ML_bmp_or_cl(Realisation_Bibliotheques, 0, 0, 128, 128);
	GetKey(&key);
	if(key==KEY_CTRL_EXIT) return 0;
	
	for(a = 0; a > -65; a--) {
		ML_clear_vram();
		ML_bmp_or_cl(Realisation_Bibliotheques, 0, a, 128, 128);
		ML_display_vram();
		Sleep(24);
		a--;
	}
	GetKey(&key);
	if(key==KEY_CTRL_EXIT) return 0;
	
	ML_clear_vram();
	dispStr("Remerciements sp\x89""ciaux",20,1);
	dispStr("Les membres de Plan\x90te Casio pour leurs conseils et leur patience.",2,15);
	dispStr("Tous mes amis, pour leurs id\x89""es et leurs encouragements !",2,45);
	ML_rectangle(0,0,128,9,1,ML_XOR,ML_XOR);
	GetKey(&key);
	if(key==KEY_CTRL_EXIT) return 0;
	
	ML_clear_vram();
	ML_bmp_or(LogoPlaneteCasio, 0, 0, 128, 64);
	do {
		GetKey(&key);
	} while(key != KEY_CTRL_EXE);
}
int FONTCHARACTER_search(const FONTCHARACTER s[], char c) {
	int i = 0;
	while(s[i] != 0) i++;
	i--;
	while(i != 0) {
		if(s[i] == c) return i;
		i--;
	}
	return 0;
}

void Display_Progression_Analyse(void) {
	long r = ((progression_actuelle*81)/progression_maximale);
	ML_rectangle(44, 20, 44+r, 24, 0, 0, ML_BLACK);
	ML_display_vram();
}
void Display_Progression_Traitement(void) {
	long r = ((progression_actuelle*81)/progression_maximale);
	ML_rectangle(44, 33, 44+r, 37, 0, 0, ML_BLACK);
	ML_display_vram();
}
void Display_Progression_Ecriture(void) {
	long r = ((progression_actuelle*81)/progression_maximale);
	ML_rectangle(44, 46, 44+r, 50, 0, 0, ML_BLACK);
	ML_display_vram();
}

void Type_and_add_extension(char no, FONTCHARACTER* file, char *str){
	char *ext = 0, i = 1, fin_du_nom = 0;

	if(no == 4) {
		fin_du_nom = FONTCHARACTER_search(file, '.');
		if(fin_du_nom == 0) while(file[fin_du_nom] != 0) fin_du_nom++;
		if(fin_du_nom > 8) fin_du_nom = 8;
		str[fin_du_nom] = '\0';
		locate__Print(3, no, str);
	}

	EI_init();
	EI_manage_config(EI_SET_COLUMN, fin_du_nom+3);
	EI_manage_config(EI_SET_ROW, no);
	EI_manage_config(EI_SET_START_MODE, EI_NORMAL);
	while(i) {
		if(no == 4)
			ext = EI_input_string(4, (const char*)".0123456789abcdefghijklmnopqrstuvwxyz");
		else
			ext = EI_input_string(8, (const char*)"0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ");
		if(ext[0]) i = 0;
	}

	for(i = 0; i <= (4*no - 12); i++) {
		file[fin_du_nom + i] = ext[i];
		str[fin_du_nom + i] = ext[i];
		if(ext[i] == 0) break;
	}
	free(ext);

	if(no == 5) {
		i = 0;
		while(file[i]) i++;
		file[i] = '.';
		file[i+1] = 'h';
		file[i+2] = 'u';
		file[i+3] = 'f';
		file[i+4] = '\0';
		for(fin_du_nom = i; fin_du_nom <= i+4; fin_du_nom++)
			str[fin_du_nom] = file[fin_du_nom];
	}

}

void Afficher_Nombre_Betterfont(int n, const int x, const char y){
	char s[20]="";
	int i,j,sign;
	char c;
	if((sign=n)<0) n=-n;
	i=0;
	do{
		s[i++]=n%10+'0';
	}while((n/=10)>0);
	if(sign<0)
	s[i++]='-';
	s[i]='\0';
	for(i=0,j=strlen(s)-1;i<j;i++,j--){
		c=s[i];
		s[i]=s[j];
		s[j]=c;
	}
	
	dispStr(s, x, y);
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum){return INIT_ADDIN_APPLICATION(isAppli, OptionNum);}
#pragma section
